///////////////////////////////////////////////////////
//        MAS Network Graph Sketch, v 1.0cx          //
///////////////////////////////////////////////////////
//                                                   //
// Graph for Manning Atkinson and Sohi Architecture  //
// Website. To be exported into Processing.js        //
// Written in Processing 2.0b3                       //
//                                                   //
// Written by Xan Manning                            //
//                                                   //
///////////////////////////////////////////////////////

int nTriangles = 2;
int nBorder = int(random(30, 50));
int nWidth = 280;
int nHeight = 280;
//PImage bgImg = loadImage("bgimg.png");
int nMaxWiggle = int(random(10, 30));
float nTransitionSteps = 100;
float fFrameRate = 29.97;
boolean nReverse = false;
boolean pause = false;

// No Touch
  float fSpeed = 1 / nTransitionSteps;
  int nStepCount = 0;
  int nPoints = nTriangles * 3;
  float[] fDist = new float[nPoints];
  float[] nWiggle =  new float[nPoints];
  PVector[] vTranslate = new PVector[nPoints];
  PVector[] vStep = new PVector[nPoints];
  PVector[] vPoints = new PVector[nPoints];
  int bottler;

void setup() {
  frameRate(fFrameRate);
  size(nWidth, nHeight);
  background(255, 0);
  for(int i = 0 ; i < nPoints ; i++) {
    bottler = 85;
    fDist[i] = random(50, 200);
    if(i == 0) {
      vPoints[i] = new PVector(80, 235);
    } else if(i == 2) {
      vPoints[i] = new PVector(240, 100);
    } else {
      vPoints[i] = new PVector(int(random(nBorder + bottler, width - nBorder)), int(random(nBorder + bottler, height - nBorder)));
    }
    vStep[i] = vPoints[i];
    vTranslate[i] = new PVector(random(-nMaxWiggle, nMaxWiggle), random(-nMaxWiggle, nMaxWiggle));
  }

}

void draw() {
    background(255, 0);
    strokeCap(ROUND);
    noStroke();
    //beginShape(TRIANGLE_FAN);
    beginShape(TRIANGLE_STRIP);
    //println(nStepCount);
    for(int i = 0 ; i < nPoints ; i++) {
      if(vPoints[i].x < vTranslate[i].x) {
        if(!nReverse) {
          vStep[i].x += (vTranslate[i].x / nTransitionSteps);
        } else {
          vStep[i].x -= (vTranslate[i].x / nTransitionSteps);
        }
      } else {
        if(!nReverse) {
          vStep[i].x -= (vTranslate[i].x / nTransitionSteps);
        } else {
          vStep[i].x += (vTranslate[i].x / nTransitionSteps);
        }
      }
      
      if(vPoints[i].y < vTranslate[i].y) {
        if(!nReverse) {
          vStep[i].y += (vTranslate[i].y / nTransitionSteps);
        } else {
          vStep[i].y -= (vTranslate[i].y / nTransitionSteps);
        }
      } else {
        if(!nReverse) {
          vStep[i].y -= (vTranslate[i].y / nTransitionSteps);
        } else {
          vStep[i].y += (vTranslate[i].y / nTransitionSteps);
        }
      }
      
      fill(0, 180 - (fDist[i] * 0.8), 255 - fDist[i], 255 - fDist[i]);
      vertex(vPoints[i].x, vPoints[i].y);
      stroke(0, 100, 200);
      strokeWeight(5);
      point(vPoints[i].x, vPoints[i].y);
      noStroke();
    }
    
    smooth();
    
    nStepCount++;
    
    if(nStepCount > nTransitionSteps) {
      if(!nReverse) {
        nReverse = true;
      } else {
        nReverse = false;
      }
      nStepCount = 0;
    }
    
    endShape(CLOSE);
    
    stroke(200, 150);
    strokeWeight(15);
    strokeCap(SQUARE);
    noFill();
    beginShape();
    vertex(95, 30);
    vertex(105, 40);
    vertex(105, 120);
    vertex(55, 240);
    vertex(65, 250);
    vertex(225, 250);
    vertex(235, 240);
    vertex(185, 120);
    vertex(185, 40);
    vertex(195, 30);
    endShape();
}



