///////////////////////////////////////////////////////
//        MAS Network Graph Sketch, v 1.0            //
///////////////////////////////////////////////////////
//                                                   //
// Graph for Manning Atkinson and Sohi Architecture  //
// Website. To be exported into Processing.js        //
// Written in Processing 2.0b3                       //
//                                                   //
// Written by Xan Manning                            //
//                                                   //
///////////////////////////////////////////////////////

int nPoints = 12;
int nBorder = int(random(10, 30));
int nWidth = 350;
int nHeight = 600;
//PImage bgImg = loadImage("bgimg.png");
int nMaxWiggle = int(random(10, 50));
float nTransitionSteps = 100;
float fFrameRate = 29.97;
boolean nReverse = false;
boolean pause = false;
float[] nWiggle =  new float[nPoints];
PVector[] vTranslate = new PVector[nPoints];
PVector[] vStep = new PVector[nPoints];
PVector[] vPoints = new PVector[nPoints];

// No Touch
  float fSpeed = 1 / nTransitionSteps;
  int nStepCount = 0;

void setup() {
  frameRate(fFrameRate);
  size(nWidth, nHeight);
  background(255);
  for(int i = 0 ; i < nPoints ; i++) {
    vPoints[i] = new PVector(int(random(nBorder, width - nBorder)), int(random(nBorder, height - nBorder)));
    vStep[i] = vPoints[i];
    vTranslate[i] = new PVector(random(-nMaxWiggle, nMaxWiggle), random(-nMaxWiggle, nMaxWiggle));
  }
  
  //println(vPoints);
  //println(vStep);
  //println(vTranslate);
}

void draw() {
    background(255);
    //println(nStepCount);
    for(int i = 0 ; i < nPoints ; i++) {
      if(vPoints[i].x < vTranslate[i].x) {
        if(!nReverse) {
          vStep[i].x += (vTranslate[i].x / nTransitionSteps);
        } else {
          vStep[i].x -= (vTranslate[i].x / nTransitionSteps);
        }
      } else {
        if(!nReverse) {
          vStep[i].x -= (vTranslate[i].x / nTransitionSteps);
        } else {
          vStep[i].x += (vTranslate[i].x / nTransitionSteps);
        }
      }
      
      if(vPoints[i].y < vTranslate[i].y) {
        if(!nReverse) {
          vStep[i].y += (vTranslate[i].y / nTransitionSteps);
        } else {
          vStep[i].y -= (vTranslate[i].y / nTransitionSteps);
        }
      } else {
        if(!nReverse) {
          vStep[i].y -= (vTranslate[i].y / nTransitionSteps);
        } else {
          vStep[i].y += (vTranslate[i].y / nTransitionSteps);
        }
      }
      
      //println(vStep[i]);
        
      for(int j = 0 ; j < nPoints ; j++) {
          if(j != i) {
            float fDist = dist(vStep[i].x, vStep[i].y, vStep[j].x, vStep[j].y);
            if(fDist < 255) {
              strokeWeight(1.2);
              stroke(0, 180 - (fDist * 0.8), 255 - fDist, 255 - fDist);
              line(vStep[i].x, vStep[i].y, vStep[j].x, vStep[j].y);
            }
        }
      }
      stroke(0, 100, 200);
      strokeWeight(5);
      point(vPoints[i].x, vPoints[i].y);
    }
    
    smooth();
    
    nStepCount++;
    
    if(nStepCount > nTransitionSteps) {
      if(!nReverse) {
        nReverse = true;
      } else {
        nReverse = false;
      }
      nStepCount = 0;
    }
    
    saveFrame("network-####.png");
}


