///////////////////////////////////////////////////////
//        MAS Network Graph Sketch, v 1.0c           //
///////////////////////////////////////////////////////
//                                                   //
// Graph for Manning Atkinson and Sohi Architecture  //
// Website. To be exported into Processing.js        //
// Written in Processing 2.0b3                       //
//                                                   //
// Written by Xan Manning                            //
//                                                   //
///////////////////////////////////////////////////////

int nTriangles = 4;
int nBorder = int(random(20, 40));
int nWidth = 350;
int nHeight = 600;
//PImage bgImg = loadImage("bgimg.png");
int nMaxWiggle = int(random(10, 50));
float nTransitionSteps = 100;
float fFrameRate = 29.97;
boolean nReverse = false;
boolean pause = false;

// No Touch
  float fSpeed = 1 / nTransitionSteps;
  int nStepCount = 0;
  int nPoints = nTriangles * 3;
  float[] fDist = new float[nPoints];
  float[] nWiggle =  new float[nPoints];
  PVector[] vTranslate = new PVector[nPoints];
  PVector[] vStep = new PVector[nPoints];
  PVector[] vPoints = new PVector[nPoints];

void setup() {
  frameRate(fFrameRate);
  size(nWidth, nHeight);
  background(255, 0);
  for(int i = 0 ; i < nPoints ; i++) {
    fDist[i] = random(50, 255);
    vPoints[i] = new PVector(int(random(nBorder, width - nBorder)), int(random(nBorder, height - nBorder)));
    vStep[i] = vPoints[i];
    vTranslate[i] = new PVector(random(-nMaxWiggle, nMaxWiggle), random(-nMaxWiggle, nMaxWiggle));
  }

}

void draw() {
    background(255, 0);
    noStroke();
    //beginShape(TRIANGLE_FAN);
    beginShape(TRIANGLE_STRIP);
    //println(nStepCount);
    for(int i = 0 ; i < nPoints ; i++) {
      if(vPoints[i].x < vTranslate[i].x) {
        if(!nReverse) {
          vStep[i].x += (vTranslate[i].x / nTransitionSteps);
        } else {
          vStep[i].x -= (vTranslate[i].x / nTransitionSteps);
        }
      } else {
        if(!nReverse) {
          vStep[i].x -= (vTranslate[i].x / nTransitionSteps);
        } else {
          vStep[i].x += (vTranslate[i].x / nTransitionSteps);
        }
      }
      
      if(vPoints[i].y < vTranslate[i].y) {
        if(!nReverse) {
          vStep[i].y += (vTranslate[i].y / nTransitionSteps);
        } else {
          vStep[i].y -= (vTranslate[i].y / nTransitionSteps);
        }
      } else {
        if(!nReverse) {
          vStep[i].y -= (vTranslate[i].y / nTransitionSteps);
        } else {
          vStep[i].y += (vTranslate[i].y / nTransitionSteps);
        }
      }
      
      fill(0, 180 - (fDist[i] * 0.8), 255 - fDist[i], 255 - fDist[i]);
      vertex(vPoints[i].x, vPoints[i].y);
      stroke(0, 100, 200);
      strokeWeight(5);
      point(vPoints[i].x, vPoints[i].y);
      noStroke();
    }
    
    smooth();
    
    nStepCount++;
    
    if(nStepCount > nTransitionSteps) {
      if(!nReverse) {
        nReverse = true;
      } else {
        nReverse = false;
      }
      nStepCount = 0;
    }
    
    endShape(CLOSE);
}


